'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x6, _x7, _x8) { var _again = true; _function: while (_again) { var object = _x6, property = _x7, receiver = _x8; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x6 = parent; _x7 = property; _x8 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactVirtualized = require('react-virtualized');

var _reactDndScrollzone = require('react-dnd-scrollzone');

var _reactDndScrollzone2 = _interopRequireDefault(_reactDndScrollzone);

var _AdainTreeNode = require('./AdainTreeNode');

var _AdainTreeNode2 = _interopRequireDefault(_AdainTreeNode);

var _AdainTreeNodeRenderDefault = require('./AdainTreeNodeRenderDefault');

var _AdainTreeNodeRenderDefault2 = _interopRequireDefault(_AdainTreeNodeRenderDefault);

var _utilsTreeDataUtils = require('./utils/tree-data-utils');

var _utilsMemoizedTreeDataUtils = require('./utils/memoized-tree-data-utils');

var _utilsGenericUtils = require('./utils/generic-utils');

var _utilsDefaultHandlers = require('./utils/default-handlers');

var _utilsDragAndDropUtils = require('./utils/drag-and-drop-utils');

var _AdainTreeHeader = require("./AdainTreeHeader");

var _AdainTreeHeader2 = _interopRequireDefault(_AdainTreeHeader);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var dndTypeCounter = 1;

var AdainTree = (function (_React$Component) {
	_inherits(AdainTree, _React$Component);

	function AdainTree(props) {
		_classCallCheck(this, AdainTree);

		_get(Object.getPrototypeOf(AdainTree.prototype), 'constructor', this).call(this, props);

		var dndType = props.dndType;
		var nodeContentRenderer = props.nodeContentRenderer;
		var isVirtualized = props.isVirtualized;
		var slideRegionSize = props.slideRegionSize;
		var header = props.header;
		var treeData = props.treeData;
		var type = props.type;

		// Wrapping classes for use with react-dnd
		this.dndType = dndType || 'rst__' + dndTypeCounter;
		dndTypeCounter += 1;
		this.nodeContentRenderer = (0, _utilsDragAndDropUtils.dndWrapSource)(nodeContentRenderer, this.dndType);
		this.treeNodeRenderer = (0, _utilsDragAndDropUtils.dndWrapTarget)(_AdainTreeNode2['default'], this.dndType);

		// Prepare scroll-on-drag options for this list
		if (isVirtualized) {
			this.scrollZoneVirtualList = (0, _reactDndScrollzone2['default'])(_reactVirtualized.List);
			this.vStrength = (0, _reactDndScrollzone.createVerticalStrength)(slideRegionSize);
			this.hStrength = (0, _reactDndScrollzone.createHorizontalStrength)(slideRegionSize);
		}

		this.state = {
			draggingTreeData: null,
			swapFrom: null,
			swapLength: null,
			swapDepth: null,
			rows: this.getRows(treeData),
			header: header,
			type: type,
			searchMatches: [],
			searchFocusTreeIndex: null,
			canNodeDrop: true
		};

		this.toggleChildrenVisibility = this.toggleChildrenVisibility.bind(this);
		this.moveNode = this.moveNode.bind(this);
		this.startDrag = this.startDrag.bind(this);
		this.dragHover = this.dragHover.bind(this);
		this.endDrag = this.endDrag.bind(this);

		this.sortHandle = this.sortHandle.bind(this);
		this.removeAllSelected = this.removeAllSelected.bind(this);
	}

	_createClass(AdainTree, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.loadLazyChildren();
			this.search(this.props, false, false);
			this.ignoreOneTreeUpdate = false;
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			this.setState({ searchFocusTreeIndex: null });
			if (this.props.treeData !== nextProps.treeData) {
				// Ignore updates caused by search, in order to avoid infinite looping
				if (this.ignoreOneTreeUpdate) {
					this.ignoreOneTreeUpdate = false;
				} else {
					this.loadLazyChildren(nextProps);
					// Load any children defined by a function
					this.search(nextProps, false, false);
				}

				// Calculate the rows to be shown from the new tree data
				this.setState({
					draggingTreeData: null,
					swapFrom: null,
					swapLength: null,
					swapDepth: null,
					rows: this.getRows(nextProps.treeData)
				});
			} else if (!_lodash2['default'].isEqual(this.props.searchQuery, nextProps.searchQuery)) {
				this.search(nextProps);
			} else if (this.props.searchFocusOffset !== nextProps.searchFocusOffset) {
				this.search(nextProps, true, true, true);
			}
		}
	}, {
		key: 'getRows',
		value: function getRows(treeData) {
			return (0, _utilsTreeDataUtils.getFlatDataFromTree)({
				ignoreCollapsed: true,
				getNodeKey: this.props.getNodeKey,
				treeData: treeData
			});
		}
	}, {
		key: 'toggleChildrenVisibility',
		value: function toggleChildrenVisibility(_ref) {
			var targetNode = _ref.node;
			var path = _ref.path;

			var treeData = (0, _utilsTreeDataUtils.changeNodeAtPath)({
				treeData: this.props.treeData,
				path: path,
				newNode: function newNode(_ref2) {
					var node = _ref2.node;
					return _extends({}, node, { expanded: !node.expanded });
				},
				getNodeKey: this.props.getNodeKey
			});

			this.props.onChange(treeData);

			if (this.props.onVisibilityToggle) {
				this.props.onVisibilityToggle({
					treeData: treeData,
					node: targetNode,
					expanded: !targetNode.expanded
				});
			}
		}
	}, {
		key: 'moveNode',
		value: function moveNode(_ref3) {
			var node = _ref3.node;
			var depth = _ref3.depth;
			var minimumTreeIndex = _ref3.minimumTreeIndex;

			var _insertNode = (0, _utilsTreeDataUtils.insertNode)({
				treeData: this.state.draggingTreeData,
				newNode: node,
				depth: depth,
				minimumTreeIndex: minimumTreeIndex,
				expandParent: true,
				getNodeKey: this.props.getNodeKey
			});

			var treeData = _insertNode.treeData;
			var treeIndex = _insertNode.treeIndex;
			var path = _insertNode.path;

			this.props.onChange(treeData);

			if (this.props.onMoveNode) {
				this.props.onMoveNode({ treeData: treeData, node: node, treeIndex: treeIndex, path: path });
			}
		}
	}, {
		key: 'search',
		value: function search() {
			var props = arguments.length <= 0 || arguments[0] === undefined ? this.props : arguments[0];
			var seekIndex = arguments.length <= 1 || arguments[1] === undefined ? true : arguments[1];
			var expand = arguments.length <= 2 || arguments[2] === undefined ? true : arguments[2];
			var singleSearch = arguments.length <= 3 || arguments[3] === undefined ? false : arguments[3];
			var treeData = props.treeData;
			var onChange = props.onChange;
			var searchFinishCallback = props.searchFinishCallback;
			var searchQuery = props.searchQuery;
			var searchMethod = props.searchMethod;
			var searchFocusOffset = props.searchFocusOffset;

			// Skip search if no conditions are specified
			if ((searchQuery === null || typeof searchQuery === 'undefined' || String(searchQuery) === '') && !searchMethod) {
				this.setState({
					searchMatches: []
				});

				if (searchFinishCallback) {
					searchFinishCallback([]);
				}

				return;
			}

			var _find = (0, _utilsTreeDataUtils.find)({
				getNodeKey: this.props.getNodeKey,
				treeData: treeData,
				searchQuery: searchQuery,
				searchMethod: searchMethod || _utilsDefaultHandlers.defaultSearchMethod,
				searchFocusOffset: searchFocusOffset,
				expandAllMatchPaths: expand && !singleSearch,
				expandFocusMatchPaths: !!expand
			});

			var expandedTreeData = _find.treeData;
			var searchMatches = _find.matches;

			// Update the tree with data leaving all paths leading to matching nodes open
			if (expand) {
				this.ignoreOneTreeUpdate = true; // Prevents infinite loop
				onChange(expandedTreeData);
			}
			console.log('ctodo((((varName2))))'); // eslint-disable-line no-console

			if (searchFinishCallback) {
				searchFinishCallback(searchMatches);
			}

			var searchFocusTreeIndex = null;
			if (seekIndex && searchFocusOffset !== null && searchFocusOffset < searchMatches.length) {
				searchFocusTreeIndex = searchMatches[searchFocusOffset].treeIndex;
			}

			this.setState({
				searchMatches: searchMatches,
				searchFocusTreeIndex: searchFocusTreeIndex
			});
		}
	}, {
		key: 'startDrag',
		value: function startDrag(_ref4) {
			var path = _ref4.path;

			var draggingTreeData = (0, _utilsTreeDataUtils.removeNodeAtPath)({
				treeData: this.props.treeData,
				path: path,
				getNodeKey: this.props.getNodeKey
			});

			draggingTreeData.canNodeDrop = true;

			this.setState({
				draggingTreeData: draggingTreeData
			});
		}
	}, {
		key: 'dragHover',
		value: function dragHover(_ref5) {
			var draggedNode = _ref5.node;
			var depth = _ref5.depth;
			var minimumTreeIndex = _ref5.minimumTreeIndex;

			// Fall back to the tree data if something is being dragged in from
			//  an external element
			var draggingTreeData = this.state.draggingTreeData || this.props.treeData;
			var canNodeDrop = true;
			if (this.props.commonSetting && this.props.commonSetting.canNotDropNoChildren) {
				canNodeDrop = !!(this.props.treeData[minimumTreeIndex] && this.props.treeData[minimumTreeIndex].children);
			}

			var addedResult = (0, _utilsMemoizedTreeDataUtils.memoizedInsertNode)({
				treeData: draggingTreeData,
				newNode: draggedNode,
				depth: depth,
				minimumTreeIndex: minimumTreeIndex,
				expandParent: true,
				getNodeKey: this.props.getNodeKey
			});

			var rows = this.getRows(addedResult.treeData);
			var expandedParentPath = rows[addedResult.treeIndex].path;

			var swapFrom = addedResult.treeIndex;
			var swapTo = minimumTreeIndex;
			var swapLength = 1 + (0, _utilsTreeDataUtils.getDescendantCount)({ node: draggedNode });
			this.setState({
				canNodeDrop: canNodeDrop,
				rows: (0, _utilsGenericUtils.swapRows)(rows, swapFrom, swapTo, swapLength),
				swapFrom: swapFrom,
				swapLength: swapLength,
				swapDepth: depth,
				draggingTreeData: (0, _utilsTreeDataUtils.changeNodeAtPath)({
					treeData: draggingTreeData,
					path: expandedParentPath.slice(0, -1),
					newNode: function newNode(_ref6) {
						var node = _ref6.node;
						return _extends({}, node, { expanded: true });
					},
					getNodeKey: this.props.getNodeKey
				})
			});
		}
	}, {
		key: 'endDrag',
		value: function endDrag(dropResult) {
			if (!this.state.canNodeDrop || !dropResult || !dropResult.node) {
				this.setState({
					draggingTreeData: null,
					swapFrom: null,
					swapLength: null,
					swapDepth: null,
					rows: this.getRows(this.props.treeData)
				});

				return;
			}

			this.moveNode(dropResult);
		}

		/**
   * Load any children in the tree that are given by a function
   */
	}, {
		key: 'loadLazyChildren',
		value: function loadLazyChildren() {
			var _this = this;

			var props = arguments.length <= 0 || arguments[0] === undefined ? this.props : arguments[0];

			(0, _utilsTreeDataUtils.walk)({
				treeData: props.treeData,
				getNodeKey: this.props.getNodeKey,
				callback: function callback(_ref7) {
					var node = _ref7.node;
					var path = _ref7.path;
					var lowerSiblingCounts = _ref7.lowerSiblingCounts;
					var treeIndex = _ref7.treeIndex;

					// If the node has children defined by a function, and is either expanded
					//  or set to load even before expansion, run the function.
					if (node.children && typeof node.children === 'function' && (node.expanded || props.loadCollapsedLazyChildren)) {
						// Call the children fetching function
						node.children({
							node: node,
							path: path,
							lowerSiblingCounts: lowerSiblingCounts,
							treeIndex: treeIndex,

							// Provide a helper to append the new data when it is received
							done: function done(childrenArray) {
								return _this.props.onChange((0, _utilsTreeDataUtils.changeNodeAtPath)({
									treeData: _this.props.treeData,
									path: path,
									newNode: function newNode(_ref8) {
										var oldNode = _ref8.node;
										return(
											// Only replace the old node if it's the one we set off to find children
											//  for in the first place
											oldNode === node ? _extends({}, oldNode, {
												children: childrenArray
											}) : oldNode
										);
									},
									getNodeKey: _this.props.getNodeKey
								}));
							}
						});
					}
				}
			});
		}
	}, {
		key: 'renderRow',
		value: function renderRow(_ref9, listIndex, style, getPrevRow, matchKeys) {
			var node = _ref9.node;
			var parentNode = _ref9.parentNode;
			var path = _ref9.path;
			var lowerSiblingCounts = _ref9.lowerSiblingCounts;
			var treeIndex = _ref9.treeIndex;
			var _props = this.props;
			var canDrag = _props.canDrag;
			var canDrop = _props.canDrop;
			var generateNodeProps = _props.generateNodeProps;
			var getNodeKey = _props.getNodeKey;
			var maxDepth = _props.maxDepth;
			var scaffoldBlockPxWidth = _props.scaffoldBlockPxWidth;
			var searchFocusOffset = _props.searchFocusOffset;
			var onRowClick = _props.onRowClick;
			var commonSetting = _props.commonSetting;

			var TreeNodeRenderer = this.treeNodeRenderer;
			var NodeContentRenderer = this.nodeContentRenderer;
			var nodeKey = path[path.length - 1];
			var isSearchMatch = (nodeKey in matchKeys);
			var isSearchFocus = isSearchMatch && matchKeys[nodeKey] === searchFocusOffset;
			var callbackParams = {
				node: node,
				parentNode: parentNode,
				path: path,
				lowerSiblingCounts: lowerSiblingCounts,
				treeIndex: treeIndex,
				isSearchMatch: isSearchMatch,
				isSearchFocus: isSearchFocus
			};
			var nodeProps = !generateNodeProps ? {} : generateNodeProps(callbackParams);
			var rowCanDrag = typeof canDrag !== 'function' ? canDrag : canDrag(callbackParams);

			return _react2['default'].createElement(
				TreeNodeRenderer,
				{
					style: style,
					key: nodeKey,
					treeIndex: treeIndex,
					listIndex: listIndex,
					getPrevRow: getPrevRow,
					treeData: this.state.draggingTreeData || this.state.treeData,
					getNodeKey: getNodeKey,
					customCanDrop: canDrop,
					node: node,
					path: path,
					lowerSiblingCounts: lowerSiblingCounts,
					scaffoldBlockPxWidth: scaffoldBlockPxWidth,
					swapFrom: this.state.swapFrom,
					swapLength: this.state.swapLength,
					swapDepth: this.state.swapDepth,
					maxDepth: maxDepth,
					dragHover: this.dragHover
				},
				_react2['default'].createElement(NodeContentRenderer, _extends({
					node: node,
					parentNode: parentNode,
					path: path,
					isSearchMatch: isSearchMatch,
					isSearchFocus: isSearchFocus,
					treeIndex: treeIndex,
					startDrag: this.startDrag,
					endDrag: this.endDrag,
					canDrag: rowCanDrag,
					toggleChildrenVisibility: this.toggleChildrenVisibility,
					scaffoldBlockPxWidth: scaffoldBlockPxWidth,
					commonSetting: commonSetting,
					onRowClick: onRowClick,
					removeAllSelected: this.removeAllSelected
				}, nodeProps))
			);
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props2 = this.props;
			var style = _props2.style;
			var className = _props2.className;
			var innerStyle = _props2.innerStyle;
			var rowHeight = _props2.rowHeight;
			var isVirtualized = _props2.isVirtualized;
			var divHeight = _props2.divHeight;
			var _state = this.state;
			var header = _state.header;
			var rows = _state.rows;
			var searchMatches = _state.searchMatches;
			var searchFocusTreeIndex = _state.searchFocusTreeIndex;

			// Get indices for rows that match the search conditions
			var matchKeys = {};
			searchMatches.forEach(function (_ref10, i) {
				var path = _ref10.path;

				matchKeys[path[path.length - 1]] = i;
			});

			// Seek to the focused search result if there is one specified
			var scrollToInfo = searchFocusTreeIndex !== null ? { scrollToIndex: searchFocusTreeIndex } : {};

			var containerStyle = style;
			var list = undefined;
			if (isVirtualized) {
				(function () {
					containerStyle = _extends({ height: '100%' }, containerStyle);

					var ScrollZoneVirtualList = _this2.scrollZoneVirtualList;
					// Render list with react-virtualized
					list = _react2['default'].createElement(
						_reactVirtualized.AutoSizer,
						null,
						function (_ref11) {
							var height = _ref11.height;
							var width = _ref11.width;
							return _react2['default'].createElement(ScrollZoneVirtualList, _extends({}, scrollToInfo, {
								verticalStrength: _this2.vStrength,
								horizontalStrength: _this2.hStrength,
								speed: 30,
								scrollToAlignment: 'start',
								className: 'virtualScrollOverride',
								width: width,
								onScroll: function (_ref12) {
									var scrollTop = _ref12.scrollTop;

									_this2.scrollTop = scrollTop;
								},
								height: height,
								style: innerStyle,
								rowCount: rows.length,
								estimatedRowSize: typeof rowHeight !== 'function' ? rowHeight : undefined,
								rowHeight: rowHeight,
								rowRenderer: function (_ref13) {
									var index = _ref13.index;
									var rowStyle = _ref13.style;
									return _this2.renderRow(rows[index], index, rowStyle, function () {
										return rows[index - 1] || null;
									}, matchKeys);
								}
							}, _this2.props.reactVirtualizedListProps));
						}
					);
				})();
			} else {
				// Render list without react-virtualized
				list = rows.map(function (row, index) {
					return _this2.renderRow(row, index, {
						height: typeof rowHeight !== 'function' ? rowHeight : rowHeight({ index: index })
					}, function () {
						return rows[index - 1] || null;
					}, matchKeys);
				});
			}

			var height = Number(divHeight);
			var gridHeight = height;
			if (header) {
				gridHeight -= this.props.headerHeight;
			}

			return _react2['default'].createElement(
				'div',
				{ className: 'treeContainer', style: { height: height } },
				header && _react2['default'].createElement(_AdainTreeHeader2['default'], { header: header, onHeaderClick: this.sortHandle }),
				_react2['default'].createElement(
					'div',
					{ className: 'treeBody', style: { height: gridHeight } },
					_react2['default'].createElement(
						'div',
						{ className: "tree" + (className ? ' ' + className : ''), style: containerStyle },
						list
					)
				)
			);
		}
	}, {
		key: 'sortHandle',
		value: function sortHandle() {
			var sortHeader = this.state.sortHeader === 'asc' ? 'desc' : 'asc';

			this.sortTreeData(sortHeader);

			this.setState({
				sortHeader: sortHeader
			});
		}
	}, {
		key: 'sortTreeData',
		value: function sortTreeData(reverse) {
			var treeData = _lodash2['default'].sortBy(this.props.treeData, 'title');
			if (reverse === 'desc') {
				treeData.reverse();
			}

			this.props.onChange(treeData);
		}
	}, {
		key: 'removeAllSelected',
		value: function removeAllSelected(selectedIndex) {
			var treeData = this.props.treeData;
			var index = 0;
			var traverse = function traverse(item, selectedIndex) {
				item.selected = index === selectedIndex;
				index++;
				if (item.children) {
					var _len = item.children.length;
					for (var i = 0; i < _len; i++) {
						traverse(item.children[i], selectedIndex);
					}
				}
			};

			var len = treeData.length;
			for (var i = 0; i < len; i++) {
				traverse(treeData[i], selectedIndex);
			}

			this.props.onChange(treeData);
		}
	}]);

	return AdainTree;
})(_react2['default'].Component);

AdainTree.propTypes = {
	// Tree data in the following format:
	// [{title: 'main', subtitle: 'sub'}, { title: 'value2', expanded: true, children: [{ title: 'value3') }] }]
	// `title` is the primary label for the node
	// `subtitle` is a secondary label for the node
	// `expanded` shows children of the node if true, or hides them if false. Defaults to false.
	// `children` is an array of child nodes belonging to the node.
	treeData: _propTypes2['default'].arrayOf(_propTypes2['default'].object).isRequired,

	header: _propTypes2['default'].arrayOf(_propTypes2['default'].object),

	divHeight: _propTypes2['default'].string.isRequired,

	// Style applied to the container wrapping the tree (style defaults to {height: '100%'})
	style: _propTypes2['default'].shape({}),

	// Class name for the container wrapping the tree
	className: _propTypes2['default'].string,

	// Style applied to the inner, scrollable container (for padding, etc.)
	innerStyle: _propTypes2['default'].shape({}),

	// Used by react-virtualized
	// Either a fixed row height (number) or a function that returns the
	// height of a row given its index: `({ index: number }): number`
	rowHeight: _propTypes2['default'].oneOfType([_propTypes2['default'].number, _propTypes2['default'].func]),

	// Size in px of the region near the edges that initiates scrolling on dragover
	slideRegionSize: _propTypes2['default'].number.isRequired, // eslint-disable-line react/no-unused-prop-types

	// Custom properties to hand to the react-virtualized list
	// https://github.com/bvaughn/react-virtualized/blob/master/docs/List.md#prop-types
	reactVirtualizedListProps: _propTypes2['default'].shape({}),

	// The width of the blocks containing the lines representing the structure of the tree.
	scaffoldBlockPxWidth: _propTypes2['default'].number,

	// Maximum depth nodes can be inserted at. Defaults to infinite.
	maxDepth: _propTypes2['default'].number,

	// The method used to search nodes.
	// Defaults to a function that uses the `searchQuery` string to search for nodes with
	// matching `title` or `subtitle` values.
	// NOTE: Changing `searchMethod` will not update the search, but changing the `searchQuery` will.
	searchMethod: _propTypes2['default'].func, // eslint-disable-line react/no-unused-prop-types

	// Used by the `searchMethod` to highlight and scroll to matched nodes.
	// Should be a string for the default `searchMethod`, but can be anything when using a custom search.
	searchQuery: _propTypes2['default'].any, // eslint-disable-line react/forbid-prop-types

	// Outline the <`searchFocusOffset`>th node and scroll to it.
	searchFocusOffset: _propTypes2['default'].number,

	// Get the nodes that match the search criteria. Used for counting total matches, etc.
	searchFinishCallback: _propTypes2['default'].func, // eslint-disable-line react/no-unused-prop-types

	// Generate an object with additional props to be passed to the node renderer.
	// Use this for adding buttons via the `buttons` key,
	// or additional `style` / `className` settings.
	generateNodeProps: _propTypes2['default'].func,

	// Set to false to disable virtualization.
	// NOTE: Auto-scrolling while dragging, and scrolling to the `searchFocusOffset` will be disabled.
	isVirtualized: _propTypes2['default'].bool,

	// Override the default component for rendering nodes (but keep the scaffolding generator)
	// This is an advanced option for complete customization of the appearance.
	// It is best to copy the component in `node-renderer-default.js` to use as a base, and customize as needed.
	nodeContentRenderer: _propTypes2['default'].func,

	// Determine the unique key used to identify each node and
	// generate the `path` array passed in callbacks.
	// By default, returns the index in the tree (omitting hidden nodes).
	getNodeKey: _propTypes2['default'].func,

	// Called whenever tree data changed.
	// Just like with React input elements, you have to update your
	// own component's data to see the changes reflected.
	onChange: _propTypes2['default'].func.isRequired,

	// Called after node move operation.
	onMoveNode: _propTypes2['default'].func,

	// Determine whether a node can be dragged. Set to false to disable dragging on all nodes.
	canDrag: _propTypes2['default'].oneOfType([_propTypes2['default'].func, _propTypes2['default'].bool]),

	// Determine whether a node can be dropped based on its path and parents'.
	canDrop: _propTypes2['default'].func,

	// Called after children nodes collapsed or expanded.
	onVisibilityToggle: _propTypes2['default'].func,

	dndType: _propTypes2['default'].string
};

AdainTree.defaultProps = {
	canDrag: true,
	canDrop: null,
	className: '',
	dndType: null,
	generateNodeProps: null,
	getNodeKey: _utilsDefaultHandlers.defaultGetNodeKey,
	innerStyle: {},
	isVirtualized: true,
	maxDepth: null,
	nodeContentRenderer: _AdainTreeNodeRenderDefault2['default'],
	onMoveNode: null,
	onVisibilityToggle: null,
	reactVirtualizedListProps: {},
	rowHeight: 62,
	headerHeight: 50,
	scaffoldBlockPxWidth: 44,
	searchFinishCallback: null,
	searchFocusOffset: null,
	searchMethod: null,
	searchQuery: null,
	slideRegionSize: 100,
	style: {}
};

// Export the tree component without the react-dnd DragDropContext,
// for when component is used with other components using react-dnd.
// see: https://github.com/gaearon/react-dnd/issues/186
exports.SortableTreeWithoutDndContext = AdainTree;
exports['default'] = (0, _utilsDragAndDropUtils.dndWrapRoot)(AdainTree);